diff -urp tzdata-2008h/tzdata2008h/backward tzdata-2008h-2/tzdata2008h/backward
--- tzdata-2008h/tzdata2008h/backward	2008-09-10 04:33:26.000000000 +0200
+++ tzdata-2008h-2/tzdata2008h/backward	2008-10-16 15:50:23.000000000 +0200
@@ -5,7 +5,6 @@
 
 Link	Africa/Asmara		Africa/Asmera
 Link	Africa/Bamako		Africa/Timbuktu
-Link	America/Argentina/Catamarca	America/Argentina/ComodRivadavia
 Link	America/Adak		America/Atka
 Link	America/Argentina/Buenos_Aires	America/Buenos_Aires
 Link	America/Argentina/Catamarca	America/Catamarca
Only in tzdata-2008h-2/tzdata2008h/: backward~
diff -urp tzdata-2008h/tzdata2008h/southamerica tzdata-2008h-2/tzdata2008h/southamerica
--- tzdata-2008h/tzdata2008h/southamerica	2008-10-08 14:46:17.000000000 +0200
+++ tzdata-2008h-2/tzdata2008h/southamerica	2008-10-17 14:21:56.000000000 +0200
@@ -344,7 +344,7 @@ Zone America/Argentina/Buenos_Aires -3:5
 			-3:00	Arg	AR%sT
 #
 # Santa Fe (SF), Entre Rios (ER), Corrientes (CN), Misiones (MN), Chaco (CC),
-# Formosa (FM), Salta (SA), Santiago del Estero (SE), Cordoba (CB),
+# Formosa (FM), Santiago del Estero (SE), Cordoba (CB),
 # La Pampa (LP), Neuquen (NQ), Rio Negro (RN)
 #
 # Shanks & Pottenger also make the following claims, which we haven't verified:
@@ -363,6 +363,17 @@ Zone America/Argentina/Cordoba -4:16:48 
 			-3:00	Arg	AR%sT	1999 Oct  3
 			-4:00	Arg	AR%sT	2000 Mar  3
 			-3:00	Arg	AR%sT
+# Salta (SA)
+Zone America/Argentina/Salta -4:16:48 - LMT	1894 Oct 31
+			-4:16:48 -	CMT	1920 May
+			-4:00	-	ART	1930 Dec
+			-4:00	Arg	AR%sT	1969 Oct  5
+			-3:00	Arg	AR%sT	1991 Mar  3
+			-4:00	-	WART	1991 Oct 20
+			-3:00	Arg	AR%sT	1999 Oct  3
+			-4:00	Arg	AR%sT	2000 Mar  3
+			-3:00	Arg	AR%sT	2008 Oct 19
+			-3:00	-	ART
 #
 # Tucuman (TM)
 Zone America/Argentina/Tucuman -4:20:52 - LMT	1894 Oct 31
@@ -388,7 +399,8 @@ Zone America/Argentina/La_Rioja -4:27:24
 			-4:00	Arg	AR%sT	2000 Mar  3
 			-3:00	-	ART	2004 Jun  1
 			-4:00	-	WART	2004 Jun 20
-			-3:00	Arg	AR%sT
+			-3:00	Arg	AR%sT	2008 Oct 19
+			-3:00	-	ART
 #
 # San Juan (SJ)
 Zone America/Argentina/San_Juan -4:34:04 - LMT	1894 Oct 31
@@ -401,7 +413,8 @@ Zone America/Argentina/San_Juan -4:34:04
 			-4:00	Arg	AR%sT	2000 Mar  3
 			-3:00	-	ART	2004 May 31
 			-4:00	-	WART	2004 Jul 25
-			-3:00	Arg	AR%sT
+			-3:00	Arg	AR%sT	2008 Oct 19
+			-3:00	-	ART
 #
 # Jujuy (JY)
 Zone America/Argentina/Jujuy -4:21:12 -	LMT	1894 Oct 31
@@ -417,7 +430,7 @@ Zone America/Argentina/Jujuy -4:21:12 -	
 			-4:00	Arg	AR%sT	2000 Mar  3
 			-3:00	Arg	AR%sT
 #
-# Catamarca (CT), Chubut (CH)
+# Catamarca (CT)
 Zone America/Argentina/Catamarca -4:23:08 - LMT	1894 Oct 31
 			-4:16:48 -	CMT	1920 May
 			-4:00	-	ART	1930 Dec
@@ -428,6 +441,20 @@ Zone America/Argentina/Catamarca -4:23:0
 			-4:00	Arg	AR%sT	2000 Mar  3
 			-3:00	-	ART	2004 Jun  1
 			-4:00	-	WART	2004 Jun 20
+			-3:00	Arg	AR%sT	2008 Oct 19
+			-3:00	-	ART
+#
+# Chubut (CH)
+Zone America/Argentina/ComodRivadavia -4:30:00 - LMT	1894 Oct 31
+			-4:16:48 -	CMT	1920 May
+			-4:00	-	ART	1930 Dec
+			-4:00	Arg	AR%sT	1969 Oct  5
+			-3:00	Arg	AR%sT	1991 Mar  3
+			-4:00	-	WART	1991 Oct 20
+			-3:00	Arg	AR%sT	1999 Oct  3
+			-4:00	Arg	AR%sT	2000 Mar  3
+			-3:00	-	ART	2004 Jun  1
+			-4:00	-	WART	2004 Jun 20
 			-3:00	Arg	AR%sT
 #
 # Mendoza (MZ)
@@ -445,7 +472,8 @@ Zone America/Argentina/Mendoza -4:35:16 
 			-4:00	Arg	AR%sT	2000 Mar  3
 			-3:00	-	ART	2004 May 23
 			-4:00	-	WART	2004 Sep 26
-			-3:00	Arg	AR%sT
+			-3:00	Arg	AR%sT	2008 Oct 19
+			-3:00	-	ART
 #
 # San Luis (SL)
 Zone America/Argentina/San_Luis -4:25:24 - LMT	1894 Oct 31
Only in tzdata-2008h-2/tzdata2008h/: southamerica~
diff -urp tzdata-2008h/tzdata2008h/zone.tab tzdata-2008h-2/tzdata2008h/zone.tab
--- tzdata-2008h/tzdata2008h/zone.tab	2008-10-08 14:35:57.000000000 +0200
+++ tzdata-2008h-2/tzdata2008h/zone.tab	2008-10-17 14:35:31.000000000 +0200
@@ -42,12 +42,14 @@ AQ	-7824+10654	Antarctica/Vostok	Vostok 
 AQ	-6640+14001	Antarctica/DumontDUrville	Dumont-d'Urville Station, Terre Adelie
 AQ	-690022+0393524	Antarctica/Syowa	Syowa Station, E Ongul I
 AR	-3436-05827	America/Argentina/Buenos_Aires	Buenos Aires (BA, CF)
-AR	-3124-06411	America/Argentina/Cordoba	most locations (CB, CC, CN, ER, FM, LP, MN, NQ, RN, SA, SE, SF)
+AR	-3124-06411	America/Argentina/Cordoba	most locations (CB, CC, CN, ER, FM, LP, MN, NQ, RN, SE, SF)
+AR	-2447-06525	America/Argentina/Salta	Salta (SA)
 AR	-3319-06621	America/Argentina/San_Luis	San Luis (SL)
 AR	-2411-06518	America/Argentina/Jujuy	Jujuy (JY)
 AR	-2649-06513	America/Argentina/Tucuman	Tucuman (TM)
-AR	-2828-06547	America/Argentina/Catamarca	Catamarca (CT), Chubut (CH)
+AR	-2828-06547	America/Argentina/Catamarca	Catamarca (CT)
 AR	-2926-06651	America/Argentina/La_Rioja	La Rioja (LR)
+AR	-4551-06728	America/Argentina/ComodRivadavia	Chubut (CH)
 AR	-3132-06831	America/Argentina/San_Juan	San Juan (SJ)
 AR	-3253-06849	America/Argentina/Mendoza	Mendoza (MZ)
 AR	-5138-06913	America/Argentina/Rio_Gallegos	Santa Cruz (SC)
Only in tzdata-2008h-2/tzdata2008h/: zone.tab~