diff --git a/NEWS b/NEWS
index e217a50..3b4c3b8 100644
--- a/NEWS
+++ b/NEWS
@@ -49,6 +49,11 @@ Unreleased, experimental changes
 
     Use "PST" and "PDT" for Philippine time.  (Thanks to Paul Goyette.)
 
+  Changes to zone names
+
+    Rename Europe/Kiev to Europe/Kyiv, Europe/Zaporozhye to Europe/Zaporizhzhia
+    and Europe/Uzhgorod to Europe/Uzhhorod with a backward compatibility link.
+
   Changes to code
 
     zic now always generates TZif files where time type 0 is used for
diff --git a/backward b/backward
index 51e10f4..b7db865 100644
--- a/backward
+++ b/backward
@@ -78,7 +78,10 @@ Link	America/Havana		Cuba
 Link	Africa/Cairo		Egypt
 Link	Europe/Dublin		Eire
 Link	Europe/London		Europe/Belfast
+Link	Europe/Kyiv		Europe/Kiev
 Link	Europe/Chisinau		Europe/Tiraspol
+Link	Europe/Uzhhorod		Europe/Uzhgorod
+Link	Europe/Zaporizhzhia	Europe/Zaporozhye
 Link	Europe/London		GB
 Link	Europe/London		GB-Eire
 Link	Etc/GMT			GMT+0
diff --git a/europe b/europe
index fba611f..906849b 100644
--- a/europe
+++ b/europe
@@ -3858,12 +3858,26 @@ Link	Europe/Istanbul	Asia/Istanbul	# Istanbul is in both continents.
 # * Ukrainian Government's Resolution of 20.03.1992, No. 139.
 # http://www.uazakon.com/documents/date_8u/pg_grcasa.htm
 
+# From Volodymyr Kostyrko (2018-10-02)
+# Long years ago Ukraine was considered to be a part of Russia and most city
+# names were transliterated from Russian language, not Ukrainian. Nowadays
+# original transliteration is slowly taking its place. According to the current
+# rules # it should be written 'Kyiv', not 'Kiev', and 'Zaporizhzhia', not
+# 'Zaporozhye'.
+#
+# https://mfa.gov.ua/en/page/open/id/5418
+# http://zakon.rada.gov.ua/laws/show/z0957-14
+#
+# As of right now 'Zaporizhzhia' is already twice more popular on Google
+# then 'Zaporozhye' and 'Uzhhorod' is ten times more popular then 'Uzhgorod'.
+# Yet 'Kiev' is still more popular, but 'Kyiv' tends to gain popularity.
+
 # Zone	NAME		GMTOFF	RULES	FORMAT	[UNTIL]
-# Most of Ukraine since 1970 has been like Kiev.
+# Most of Ukraine since 1970 has been like Kyiv.
 # "Kyiv" is the transliteration of the Ukrainian name, but
 # "Kiev" is more common in English.
-Zone Europe/Kiev	2:02:04 -	LMT	1880
-			2:02:04	-	KMT	1924 May  2 # Kiev Mean Time
+Zone Europe/Kyiv	2:02:04 -	LMT	1880
+			2:02:04	-	KMT	1924 May  2 # Kyiv Mean Time
 			2:00	-	EET	1930 Jun 21
 			3:00	-	MSK	1941 Sep 20
 			1:00	C-Eur	CE%sT	1943 Nov  6
@@ -3872,9 +3886,9 @@ Zone Europe/Kiev	2:02:04 -	LMT	1880
 			2:00	E-Eur	EE%sT	1995
 			2:00	EU	EE%sT
 # Ruthenia used CET 1990/1991.
-# "Uzhhorod" is the transliteration of the Rusyn/Ukrainian pronunciation, but
-# "Uzhgorod" is more common in English.
-Zone Europe/Uzhgorod	1:29:12 -	LMT	1890 Oct
+# "Uzhhorod" is the transliteration of the Rusyn/Ukrainian pronunciation, and
+# "Uzhgorod" is less common in English.
+Zone Europe/Uzhhorod	1:29:12 -	LMT	1890 Oct
 			1:00	-	CET	1940
 			1:00	C-Eur	CE%sT	1944 Oct
 			1:00	1:00	CEST	1944 Oct 26
@@ -3885,12 +3899,13 @@ Zone Europe/Uzhgorod	1:29:12 -	LMT	1890 Oct
 			2:00	-	EET	1992
 			2:00	E-Eur	EE%sT	1995
 			2:00	EU	EE%sT
-# Zaporozh'ye and eastern Lugansk oblasts observed DST 1990/1991.
-# "Zaporizhia" is the transliteration of the Ukrainian name, but
-# "Zaporozh'ye" is more common in English.  Use the common English
+# Zaporizhzhia and eastern Lugansk oblasts observed DST 1990/1991.
+# "Zaporizhia" is other variant of transliteration, quite popular too
+# yet "Zaporizhzhia" is the official transliteration of the Ukrainian name, and
+# "Zaporozh'ye"/"Zaporozhye" is less common in English. Use the common English
 # spelling, except omit the apostrophe as it is not allowed in
 # portable Posix file names.
-Zone Europe/Zaporozhye	2:20:40 -	LMT	1880
+Zone Europe/Zaporizhzhia	2:20:40 -	LMT	1880
 			2:20	-	+0220	1924 May  2
 			2:00	-	EET	1930 Jun 21
 			3:00	-	MSK	1941 Aug 25
diff --git a/theory.html b/theory.html
index 83fba5b..358a9d6 100644
--- a/theory.html
+++ b/theory.html
@@ -454,7 +454,7 @@ in decreasing order of importance:
       HMT Havana, Helsinki, Horta, Howrah;
       IMT Irkutsk, Istanbul;
       JMT Jerusalem;
-      KMT Kaunas, Kiev, Kingston;
+      KMT Kaunas, Kyiv, Kingston;
       LMT Lima, Lisbon, local, Luanda;
       MMT Macassar, Madras, Malé, Managua, Minsk, Monrovia, Montevideo,
 	Moratuwa, Moscow;
diff --git a/zone.tab b/zone.tab
index dcb6e1d..f6ccc0e 100644
--- a/zone.tab
+++ b/zone.tab
@@ -394,9 +394,9 @@ TT	+1039-06131	America/Port_of_Spain
 TV	-0831+17913	Pacific/Funafuti
 TW	+2503+12130	Asia/Taipei
 TZ	-0648+03917	Africa/Dar_es_Salaam
-UA	+5026+03031	Europe/Kiev	Ukraine (most areas)
-UA	+4837+02218	Europe/Uzhgorod	Ruthenia
-UA	+4750+03510	Europe/Zaporozhye	Zaporozh'ye/Zaporizhia; Lugansk/Luhansk (east)
+UA	+5026+03031	Europe/Kyiv	Ukraine (most areas)
+UA	+4837+02218	Europe/Uzhhorod	Ruthenia
+UA	+4750+03510	Europe/Zaporizhzhia	Zaporozh'ye/Zaporizhia; Lugansk/Luhansk (east)
 UG	+0019+03225	Africa/Kampala
 UM	+2813-17722	Pacific/Midway	Midway Islands
 UM	+1917+16637	Pacific/Wake	Wake Island
diff --git a/zone1970.tab b/zone1970.tab
index 7c86fb6..2dd4e02 100644
--- a/zone1970.tab
+++ b/zone1970.tab
@@ -338,9 +338,9 @@ TR	+4101+02858	Europe/Istanbul
 TT,AG,AI,BL,DM,GD,GP,KN,LC,MF,MS,VC,VG,VI	+1039-06131	America/Port_of_Spain
 TV	-0831+17913	Pacific/Funafuti
 TW	+2503+12130	Asia/Taipei
-UA	+5026+03031	Europe/Kiev	Ukraine (most areas)
-UA	+4837+02218	Europe/Uzhgorod	Ruthenia
-UA	+4750+03510	Europe/Zaporozhye	Zaporozh'ye/Zaporizhia; Lugansk/Luhansk (east)
+UA	+5026+03031	Europe/Kyiv	Ukraine (most areas)
+UA	+4837+02218	Europe/Uzhhorod	Ruthenia
+UA	+4750+03510	Europe/Zaporizhzhia	Zaporozh'ye/Zaporizhia; Lugansk/Luhansk (east)
 UM	+1917+16637	Pacific/Wake	Wake Island
 US	+404251-0740023	America/New_York	Eastern (most areas)
 US	+421953-0830245	America/Detroit	Eastern - MI (most areas)